<?php
    //
    //  "Creativity tracks" by Julio Martínez (liopic at liopic.com)
    //

    // Instalation tips: put this file in a directory (with writing permisions) and call it from your HTML as an image, i.e. <img src="creativity" />


    include('../wp-config.php');   //the path to the wordpress config file

    // final size of generated PNG
    $sizeX = 530;
    $sizeY = 300;

    // the image is only generated once per day
    if( !file_exists('creativity.png') || ( date("Y-m-d",filemtime('creativity.png')) != date("Y-m-d") ) ){
        
        //Read the posts from the DB
        $posts = array();
        $db = mysql_connect(DB_HOST, DB_USER, DB_PASSWORD) or die('Could not connect to DB: ' . mysql_error());
        mysql_select_db(DB_NAME) or die('Could not select database');
        $result = mysql_query('select post_date,post_content from '.$table_prefix.'posts order by post_date desc');
        
        while ($row = mysql_fetch_assoc($result)) {
            $filteredContent = preg_replace("/[^\ a-z]/","",strtolower(str_replace("\n"," ",strip_tags($row['post_content']))));
            $auxTime = strtotime($row['post_date']);
            $positionInTheWeek = date("w",$auxTime) + (date("H",$auxTime) + date("i",$auxTime)/60 )/24;
        
            $posts[] = array( "timeInWeek" => $positionInTheWeek , "content" => $filteredContent );
        }
        
        mysql_free_result($result);
        mysql_close($db);
    
        //Count appearings of words
        $words = array();
        while(list($key,$post) = each($posts)){
            $tokens = explode(" ",$post['content']);
            while(list(,$token) = each($tokens))
                $words[$token]++;
            $posts[$key]['tokens'] = $tokens; //Save tokens for later
        }
        
        //Fill in the matrix (bitmap) with colour intensity (regarding weirdness of the words)
        reset($posts);
        while(list(,$post) = each($posts)){
            $postLength = strlen($post['content']);
            $posInPost = 0;
            $x = intval($sizeX*$post['timeInWeek']/7);
            reset($post['tokens']);
            while(list(,$token) = each($post['tokens'])){
                $y = intval($sizeY*$posInPost/$postLength);
                $matrix[$x][$y] += 1/$words[$token];
                $posInPost += strlen($token)+1;
            }

        }

        //Look the max value (to normalize later)
        $max = 0;
        for($x=0;$x<$sizeX;$x++)
            for($y=0;$y<$sizeY;$y++){
                if($matrix[$x][$y]>$max)
                    $max = $matrix[$x][$y];
            }
            
        //create image jpg and an array of colours
        $image = imagecreatetruecolor($sizeX,$sizeY);
        for($i=0;$i<256;$i++)
            $colour[$i] = imagecolorallocate($image, $i, 0, 0);

        //fill the image with $matrix
        for($x=0;$x<$sizeX;$x++)
            for($y=0;$y<$sizeY;$y++)
                imagesetpixel($image, $x, $y, $colour[ (intval(255*$matrix[$x][$y]/$max)) ] );
                
        //mark 7 days (blue vertical bars)
        $markColour = imagecolorallocate($image,0,0,250);
        for($i=1;$i<7;$i++)
            imageline($image, intval($i*$sizeX/7) , 0 , intval($i*$sizeX/7) , $sizeY-1 , $markColour);
        
        $days = array("Su","Mo","Tu","We","Th","Fr","Sa");
        while(list($key,$day) = each($days))
            imagestring($image,1,intval($key*$sizeX/7)+5,5,$day,$markColour);

        //save image in directory
        imagepng($image,"creativity.png");

    }//end of generation

    //write out the image data
    header('Content-type:image/png');
    readfile('creativity.png');
?>
